Description

Four tests are failing with

```

Errno::EADDRNOTAVAIL: Cannot assign requested address - connect(2) for "localhost" port 61953

```

when running inside a docker container

using 127.0.0.1 instead of localhost to assign address fixes the issue.

Associated revisions

Revision bf8b44f7 - 05/08/2024 03:09 PM - Ewoud Kohl van Wijngaarden

Fixes #37413 - Let the kernel assign a TCP port in tests

This binds on port 0, which lets the kernel decide which port to use.

The port is then read back from the listener. Because the kernel knows

which ports it's allowed to bind to, it removes the risk of a failure

due to collisions or policies.

History

#1 - 05/07/2024 08:19 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/891 added

#2 - 05/07/2024 08:47 AM - dosas please_edit_me

Error: test_http(SSLClientVerificationIntegrationTest): Errno::EADDRNOTAVAIL: Cannot assign requested address - connect(2) for "localhost" port

22236

/root/smart-proxy/test/test_helper.rb:55:in `initialize'

/root/smart-proxy/test/test_helper.rb:55:in `new'

/root/smart-proxy/test/test_helper.rb:55:in `can_connect?'

/root/smart-proxy/test/test_helper.rb:50:in `block in launch'

/usr/local/lib/ruby/2.7.0/timeout.rb:95:in `block in timeout'

/usr/local/lib/ruby/2.7.0/timeout.rb:33:in `block in catch'

/usr/local/lib/ruby/2.7.0/timeout.rb:33:in `catch'

/usr/local/lib/ruby/2.7.0/timeout.rb:33:in `catch'

/usr/local/lib/ruby/2.7.0/timeout.rb:110:in `timeout'

/root/smart-proxy/test/test_helper.rb:49:in `launch'

/root/smart-proxy/test/sinatra/ssl_client_verification_integration_test.rb:23:in `test_http'

20:   end

21:

22:   def test_http

=> 23:     launch protocol: 'http', plugins: [TestPluginWithSSLClientAuth]

24:     res = Net::HTTP.get_response('localhost', '/', @settings.http_port)

25:     assert_kind_of Net::HTTPSuccess, res

26:     assert_equal 'Success', res.body
#3 - 05/07/2024 10:16 AM - dosas please_edit_me

affected tests:

/root/smart-proxy/test/sinatra/ssl_client_verification_integration_test.rb:23:in `test_http

/root/smart-proxy/test/sinatra/ssl_client_verification_integration_test.rb:52:in `test_https_cert'

/root/smart-proxy/test/sinatra/ssl_client_verification_integration_test.rb:39:in `test_https_cert_from_different_authority'

/root/smart-proxy/test/sinatra/ssl_client_verification_integration_test.rb:30:in `test_https_no_cert'

#4 - 05/07/2024 01:15 PM - The Foreman Bot

- Pull request https://github.com/theforeman/smart-proxy/pull/892 added

#5 - 05/08/2024 05:34 AM - The Foreman Bot

- Pull request deleted (https://github.com/theforeman/smart-proxy/pull/891, https://github.com/theforeman/smart-proxy/pull/892)

#6 - 05/08/2024 01:32 PM - The Foreman Bot

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/smart-proxy/pull/893 added

#7 - 05/10/2024 01:00 PM - The Foreman Bot

- Fixed in Releases 3.11.0 added

#8 - 05/10/2024 01:00 PM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset bf8b44f708b852bcff20af19b63951c936854178.
